#include "GuiTools.h"

VoidPtr GetObjectPtr(Int objectID)
{
    FormPtr frm = FrmGetActiveForm();
    return(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID)));
}

VoidPtr GetObjectPtrFromForm(FormPtr frm, Int objectID)
{
    return(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID)));
}

void SetFocus(Int objectID)
{
    FormPtr frm = FrmGetActiveForm();
    FrmSetFocus(frm, FrmGetObjectIndex(frm, objectID));
}

void SetText(FieldPtr fieldPtr, CharPtr text)
{
    VoidHand textH;
    CharPtr textP;

    if (text == NULL) text = "";
    textH = MemHandleNew(StrLen(text)+1);
    if (textH == NULL) return;
    textP = MemHandleLock(textH);
    StrCopy(textP, text);
    MemHandleUnlock(textH);
    FldSetTextHandle(fieldPtr, (Handle)textH);
}

void SetTextById(Word fieldId, CharPtr text)
{
    FieldPtr field;
    field = (FieldPtr)GetObjectPtr(fieldId);
    if (field == NULL) return;
    SetText(field, text);
}

CharPtr GetText(FieldPtr fieldPtr)
{
    // Allocates new memory!
    //
    VoidHand textH;
    CharPtr textP, result;

    textH = (VoidHand)FldGetTextHandle(fieldPtr);
    if (textH == NULL) return NULL;
    textP = MemHandleLock(textH);
    result = (CharPtr)MemPtrNew(StrLen(textP)+1);
    StrCopy(result, textP);
    MemHandleUnlock(textH);
    return result;
}

CharPtr GetTextById(Word fieldId)
{
    FieldPtr field;
    field = (FieldPtr)GetObjectPtr(fieldId);
    if (field == NULL) return NULL;
    return GetText(field);
}

void PutNumInField(FieldPtr fieldPtr, Long val)
{
    CharPtr str;
    str = (CharPtr)MemPtrNew(16);
    StrIToA(str, val);
    SetText(fieldPtr, str);
    MemPtrFree(str);
}
 
Long GetNumFromField(FieldPtr fieldPtr)
{
    Long val;
    CharPtr str;
    str = GetText(fieldPtr);
    if (str == NULL) return -1;
    if (StrLen(str) == 0) { MemPtrFree(str); return -1; }
    val = StrAToI(str);
    MemPtrFree(str);
    return val;
}

